using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Net.Sockets;
using System.Net;
using System.IO;

namespace Trust
{
    public partial class ReadOnly : Form
    {
        SqlConn sq = new SqlConn();
        SqlCommand cmd;
        SqlCommand cmd1,cmd2;
        SqlDataReader dr;
        public string dfil;
        string ser1,exe,fileN;
        string fileDes;

        public ReadOnly()
        {
            InitializeComponent();
        }

        private void ReadOnly_Load(object sender, EventArgs e)
        {
            btnReadOnly.Enabled = false;
            btnSend.Enabled = false;
            listBox1.Items.Clear();
            sq.open();
            cmd = new SqlCommand("select * from IP", sq.cn);
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                if (dr.HasRows)
                {
                    listBox1.Items.Add(dr[0].ToString());
                }
            }
            dr.Close();
            sq.close();
            listBox1.SelectedIndex = 0;
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            txtFileName.Text = "";
            openFileDialog1.ShowDialog();
            txtFileName.Text = openFileDialog1.FileName;
            fileDes = openFileDialog1.FileName;
            FileInfo file = new FileInfo(fileDes);

            dfil = file.Name;
            if (fileDes == "openFileDialog1")
            {
                lblError.Text = "";
                lblError.Text = "Select a File first";
                txtFileName.Text = "";
            }
            else
            {
                fileN = fileDes.Substring(fileDes.IndexOf("\\") + 1);
                exe = fileDes.Substring(fileDes.IndexOf("."), 4);
                exe = exe.Substring(1, 3);
                if (exe == "DOC" || exe == "txt" || exe=="doc")
                {
                    btnReadOnly.Enabled = true;
                }
                else
                {
                    lblError.Text = "";
                    lblError.Text = "Choose *.doc or *.txt file only";
                }
            }


        }

        private void btnReadOnly_Click(object sender, EventArgs e)
        {
            File.SetAttributes("" + fileDes + "", FileAttributes.ReadOnly);
            lblError.Text = "";
            lblError.Text = "The file is Read Only, now try sending.";
            btnSend.Enabled = true;
        }

        private void btnSend_Click(object sender, EventArgs e)
        {


            db();
            if (listBox1.SelectedItem.ToString() == "")
            {
                lblError.Text = "";
                lblError.Text = "Select IP from List";
            }
            else
            {
                ser1 = listBox1.SelectedItem.ToString();
                send();
                File.SetAttributes(fileDes,FileAttributes.Normal);
            }
        }
        public void send()
        {
            try
            {
                IPAddress[] ipAddress = Dns.GetHostAddresses(ser1);
                IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 5656);
                Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);


                string filePath = "";


                fileDes = fileDes.Replace("\\", "/");
                while (fileDes.IndexOf("/") > -1)
                {
                    filePath += fileDes.Substring(0, fileDes.IndexOf("/") + 1);
                    fileDes = fileDes.Substring(fileDes.IndexOf("/") + 1);
                }


                byte[] fileNameByte = Encoding.ASCII.GetBytes(fileDes);

                lblError.Text = "";
                lblError.Text = "Buffering ...";
                byte[] fileData = File.ReadAllBytes(filePath + fileDes);
                byte[] clientData = new byte[4 + fileNameByte.Length + fileData.Length];
                byte[] fileNameLen = BitConverter.GetBytes(fileNameByte.Length);

                fileNameLen.CopyTo(clientData, 0);
                fileNameByte.CopyTo(clientData, 4);
                fileData.CopyTo(clientData, 4 + fileNameByte.Length);

                lblError.Text = "";
                lblError.Text = "Connection to server ...";
                clientSock.Connect(ipEnd);

                lblError.Text = "";
                lblError.Text = "File sending...";
                clientSock.Send(clientData);

                lblError.Text = "";
                lblError.Text = "Disconnecting...";
                clientSock.Close();

                lblError.Text = "";
                lblError.Text = "File transferred.";



            }

            catch (Exception ex)
            {
                if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                {
                    lblError.Text = "";
                    lblError.Text = "No Such System Available Try other IP";
                }
                else
                {
                    if (ex.Message == "No connection could be made because the target machine actively refused it")
                    {
                        lblError.Text = "";
                        lblError.Text = "File Sending fail. Because server not running.";
                    }
                    else
                    {
                        lblError.Text = "";
                        lblError.Text = "File Sending fail." + ex.Message;
                    }
                }
            }
        }
        public void db()
        {
            sq.open();
            cmd1 = new SqlCommand("insert into ReadOnly values(@fileP,@fileN)", sq.cn);
            //cmd1 = new SqlCommand("insert into ReadOnly values(@fileP,@fileN)", sq);
            cmd1.Parameters.Add(new SqlParameter("@fileP", SqlDbType.VarChar));
            cmd1.Parameters.Add(new SqlParameter("@fileN", SqlDbType.VarChar));
            cmd1.Parameters["@fileP"].Value =fileDes;
            cmd1.Parameters["@fileN"].Value = dfil;
            cmd1.ExecuteNonQuery();
            sq.close();
            sq.open();
            cmd2 = new SqlCommand("insert into valid values(@fname)", sq.cn);
            cmd2.Parameters.Add(new SqlParameter("@fname", SqlDbType.VarChar));
            cmd2.Parameters["@fname"].Value = fileN;
            cmd2.ExecuteNonQuery();
            sq.close();

        }

    }
}